unit atm19;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls;

type
  Tform1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  form1: Tform1;

implementation

{$R *.dfm}

procedure Tform1.Button1Click(Sender: TObject);
var p0,h0,p,h,t0,t,rho,Nbrmolparm3,distance : double;
    nbrmolparm2,nbrmoltotparm2,hauteurionosphere : double;
    delay,i,j : integer;
    puisEM,champsEEM,qnom,mH,vproton,c,freqEM,distvibEM : double;
    abslum,absEM : double;
    Rorbitale,vorbitale,torbitale : double;
    vmolecules, tcontact : double;
    amplbleu,altbleu : double;
    vide : double;
    Rvrai : double;
    THatmosphere : textfile;
    courbechoisie : integer;
    abslumem : double;
    puiscincontact,teqvitesse : double;
    pmes : double;
    ktherm : double;
    rhoanc,vthermo,n : double;
    rhodepart,rhofin : double;
    modifvit : boolean;
begin
  rho:=9e-60;{initialisation pour 1er calcul correct}
  modifvit:=false;
  courbechoisie:=7{1:altitude,2:pression,3:temperature en kelvin};
  {4:diffraction bleu ciel,5:absorptionfluxatomique,6:reflexionenergetiqueondeEM:!rien!}
  {7: rho et R,8:reflexionsurfaciqueondeEM,9:vitesse estimative particules}
  assignfile(THatmosphere,'THatmosphere.txt');
  rewrite(THatmosphere);
  p0:=1.013e5;
  h0:=0.0;
  nbrmolparm2:=0.0;
  nbrmoltotparm2:=0.0;
  delay:=1{10000000};
  {09012016 : puissance electromagnetique a verifier : dans les ondes}
  puisEM:=1.0e-6*sqr(sqr({vue mecanique sans cste=Ecin=rho*v2/2 soit 300}
                         {vue soucoupe et ralit}7777/2294));{w/m2}
  {24012016}
  puisEM:=puisEM*{0.65}1e-0;
  c:=3e8;{m/s}
  champsEEM:=sqrt(puisEM/c/2*2/8.85e-12);{v/m}
  qnom:=1.6e-19;
  mH:=(0.98*1+0.01*4+0.01*16)*1e-27;{kg}{He+ = 4, H+ =1, O+ =16}
  {contraire de la ralit :
  f = cst et freq augm ->inertie bloque la particule}
  vproton:=sqrt(champsEEM*qnom/mH*2);{m/s}
  freqEM:=93200000.0*1e0{10000*}{100e9}{2e9}{100000000}{3e7}{10};{Hz : ondes courtes}
  distvibEM:=vproton/freqEM;{m}
  abslum:=1.0;
  abslumem:=0.0;
  absEM:=0.0;
  amplbleu:=0.0;
  h:=1000000.0;
  hauteurionosphere:=h;
  altbleu:=207000.0;
  Rvrai:=287;
  canvas.Pen.Color:=clblack;
  if courbechoisie=9 then canvas.Brush.Color:=clwhite
                     else  canvas.Brush.Color:=clblue;
  canvas.Rectangle(500,0,1440,900);
  canvas.Pen.Color:=clwhite;
  canvas.MoveTo(550,100);
  canvas.LineTo(550-20,100+40);
  canvas.MoveTo(550,100);
  canvas.LineTo(550+20,100+40);
  canvas.MoveTo(550,800);
  canvas.LineTo(550,100);
  canvas.moveto(550,800);
  canvas.LineTo(1400,800);
  canvas.LineTo(1400-40,800-20);
  canvas.LineTo(1400,800);
  canvas.LineTo(1400-40,800+20);
  canvas.Pen.Color:=rgb(0,255,255);
  {canvas.Brush.Color:=rgb(0,255,255);}
  canvas.Font.Color:=rgb(0,255,255);
  canvas.moveto(550,round(800-700*50000/1000000));
  canvas.LineTo(1400,round(800-700*50000/1000000));
  canvas.TextOut(550,750,'altitude voyage passager : 50 km');
  canvas.Pen.Color:=rgb(255,255,255);
  if courbechoisie=1 then
  begin
    canvas.font.color:=clwhite;
    canvas.TextOut(500,80,'hauteur(m)= 1000000');
    canvas.TextOut(500,820,'hauteur(m)=0');
    canvas.TextOut(1300,820,'hauteur(m)= 1000000');
    canvas.TextOut(500,840,'hauteur(m)=0');
  end;
   if courbechoisie=2 then
  begin
    canvas.font.color:=clwhite;
    canvas.TextOut(500,80,'hauteur(m)= 1000000');
    canvas.TextOut(500,820,'hauteur(m)=0');
    canvas.TextOut(1300,820,'pression(Pa)= 1.013e5');
    canvas.TextOut(500,840,'pression(Pa)=0');
  end;
   if courbechoisie=3 then
  begin
    canvas.Pen.Color:=clwhite;
    canvas.MoveTo(round((500+1400)/2),800);
    canvas.LineTo(round((500+1400)/2),800-20);
    canvas.font.color:=clwhite;
    canvas.TextOut(500,80,'hauteur(m)= 1000000');
    canvas.TextOut(500,820,'hauteur(m)=0');
    canvas.TextOut(round((500+1300)/2),820,'temperature(K)= 273.15');
    canvas.TextOut(500,840,'temperature(K)=0');
  end;
   if courbechoisie=4 then
  begin
    canvas.font.color:=clwhite;
    canvas.TextOut(500,80,'hauteur(m)= 1000000');
    canvas.TextOut(500,820,'hauteur(m)=0');
    canvas.TextOut(1300,820,'diffraction bleu ciel (%)= 100');
    canvas.TextOut(500,840,'diffraction bleu ciel (%) = 0');
  end;
   if courbechoisie=5 then
  begin
    canvas.font.color:=clwhite;
    canvas.TextOut(500,80,'hauteur(m)= 1000000');
    canvas.TextOut(500,820,'hauteur(m)=0');
    canvas.TextOut(1300,820,'absorp. atomique (%)= 100');
    canvas.TextOut(500,840,'absorpt. atomique (%)= 0');
  end;
   if courbechoisie=6 then
  begin
    canvas.font.color:=clwhite;
    canvas.TextOut(500,80,'hauteur(m)= 1000000');
    canvas.TextOut(500,820,'hauteur(m)=0');
    canvas.TextOut(1300,820,'rlexion ondes EM (%)= 100');
    canvas.TextOut(500,840,'rflexion ondes EM  (%)= 0');
    canvas.TextOut(900,820,'frquence considre en thorie (Hz) = '
                          +floattostr(freqEM));
  end;
  if courbechoisie=7 then
  begin
    canvas.font.color:=clwhite;
    canvas.TextOut(500,80,'hauteur(m)= 1000000');
    canvas.TextOut(500,820,'hauteur(m)=0');
    canvas.TextOut(1300,820,'rho(kg/m3)= 1.22');
    canvas.TextOut(500,840,'rho(kg/m3)=0');
    canvas.font.color:=clgreen;
    canvas.TextOut(1300,800,'R = 5000');
    canvas.TextOut(500,820,'R = 0');
  end;
  if courbechoisie=8 then
  begin
    canvas.font.color:=clwhite;
    canvas.TextOut(500,80,'hauteur(m)= 1000000');
    canvas.TextOut(500,820,'hauteur(m)=0');
    canvas.TextOut(1300,820,'rlexion ondes EM (%)= 100');
    canvas.TextOut(500,840,'rflexion ondes EM  (%)= 0');
    canvas.TextOut(900,820,'frquence considre en thorie (Hz) = '
                          +floattostr(freqEM));
  end;
  if courbechoisie=9 then
  begin
    canvas.font.color:=clblack{white};
    canvas.TextOut(500,80,'hauteur(m)= 1000000');
    canvas.TextOut(500,820,'hauteur(m)=0');
    canvas.TextOut(1300,820,'v particules ? (m/s)= 10000');
    canvas.TextOut(500,840,'v particules ? (m/s)=0');
    canvas.Font.Color:=rgb(255,0,0);
    canvas.TextOut(1200,800,'k thermique(W/m/K)= 0.001');
    canvas.TextOut(500,820,'k thermique (W/m/K) = 0');
    canvas.Font.Color:=rgb(0,255,255);
    canvas.TextOut(1300,780,'temp eq contact (K)= 120000');
    canvas.TextOut(500,800,'temp eq contact (K)=0');
    canvas.Font.Color:=rgb(255,255,0);
    canvas.TextOut(1300,760,'distance (10-9 m) = 1000000');
    canvas.TextOut(500,780,'distance (10-9 m)=0');
{    canvas.Font.Color:=rgb(255,0,255);
    canvas.TextOut(1300,740,'nbrmolparm3 (6e23) = 6e23');
    canvas.TextOut(500,760,'nbrmolparm3 (6e23)=0');    }
  end;
  t0:=273.15+15.0;
  t:=t0/sqrt(sqrt(2));
  Rvrai:=297{4124};
  pmes:=p0*exp(-1*(h-h0)*9.81/(Rvrai*t))/{def temp haute alt26e10*}1.013/1.096*1.013/1.096*1.013/1.007;
  while h>=0.0 do
begin
  Rvrai:=287;
  if h>30000 then Rvrai:=297;
  if h>207000 then Rvrai:=297{4124};
  t0:=273.15+15.0;
  if h>8000.0 then t:=t0/sqrt(sqrt(2))
              else t:=t0*(1*(1-h/8000)+1/sqrt(sqrt(2))*h/8000);
  p:=p0*exp(-1*(h-h0)*9.81/(Rvrai*t));{intgrale avec Rvrai = constante : faute}
  pmes:=pmes*(0+exp(1*(1000)*9.81/(Rvrai*t)));
  rhoanc:=rho;
  rho:={modifp}pmes/Rvrai/t;
  if (h<207000.0) then
  begin
    Nbrmolparm3:=rho*1000/28*6e23;
    distance:=exp(1/3*ln(1/Nbrmolparm3));
    Rorbitale:=0.74e-10;
    vorbitale:=sqrt(5*sqr(1.6e-19)*9e9/Rorbitale/{1.7*}1e-31);
    if (h>30000*0) then torbitale:=(2*3.1416*Rorbitale)/vorbitale;
    vmolecules:=sqrt(Rvrai*t*2{1.4});
    puiscincontact:={rebond parfait=0.0}nbrmolparm3*sqr(1)*vmolecules*28*1e-27*sqr(vmolecules)/2;
    teqvitesse:=sqr(vmolecules)/Rvrai/2.0{1.4};
    ktherm:=puiscincontact/teqvitesse*distance;
    if rho<sqr(7777/340)*rhodepart then
    begin
      rhofin:=rho;
      modifvit:=true
    end
                                    else modifvit:=false;
  end
                else
  begin
    Nbrmolparm3:=rho*1000/1*6e23;
    distance:=exp(1/3*ln(1/Nbrmolparm3));
    vmolecules:=vproton;
    puiscincontact:={rebond parfait=0.0}nbrmolparm3*sqr(1)*vmolecules*1*1e-27*sqr(vmolecules)/2;
    teqvitesse:=sqr(vmolecules)/Rvrai/2{1.4};
    ktherm:=puiscincontact/teqvitesse*distance;
    if h>{750000}250000 then vthermo:=vmolecules;
    rhodepart:=rho;
  end;
  distance:=exp(1/3*ln(1/Nbrmolparm3));
{essai d'equilibre de cisaillement}
  n:=1.0{meilleure approche thorique};{?non???nergie partielle0.8};
  if ((h<> 207000.0) and (h>175000))then
  begin
    vthermo:=vthermo*(n)*sqrt(rhoanc/rho);
    teqvitesse:=sqr(vthermo)/Rvrai/2{1.4};
  end;
{puis calculs papier}
  if (h<207000.0) and(h>30000*0) then tcontact:=distance/vmolecules;
  nbrmolparm2:=nbrmolparm3*1000.000;
  nbrmoltotparm2:=nbrmoltotparm2+nbrmolparm3*1000.000;

  if nbrmoltotparm2<2.5e18 then hauteurionosphere:=h;
  if h>=00000.0 then abslum:=abslum-nbrmolparm2*2/1/1*(3.1416*sqr(1e-16));
  {selon source juin 2015 rayon noyaux = 1e-16}
  if h>207000 then abslumem:=abslumem+nbrmolparm2*2/1/1*(3.1416*sqr(1e-10));
  {selon source juin 2015 rayon noyaux = 1e-16}
  if ((h>207000.0)and(true and (distvibEM<distance))) then
     absEM:=absEM+nbrmolparm2/1/1*(3.1416*sqr(1e-10));{?1e-16?}
  if Nbrmolparm3<1/6.0e23 then vide:=h;
  memo1.Lines.Clear;
  memo1.Lines.Add('h(m) ='+floattostr(h));
  memo1.Lines.Add('t statique(c) ='+floattostr(t-273.15));
  memo1.Lines.Add('p(bar) ='+floattostr(p/1e5));
  memo1.Lines.Add('rho(kg/m3) ='+floattostr(rho));
  memo1.Lines.Add('Nombre de "molcules" par m3 ='+floattostr(Nbrmolparm3));
  memo1.Lines.Add('distance estimative entre "molcules" ='+floattostr(distance));
  memo1.Lines.Add('Nombre de "molcules" par m2 ='+floattostr(Nbrmolparm2));
  memo1.Lines.Add('estimation hauteur ionosphere (m)='+floattostr(hauteurionosphere));
  memo1.Lines.Add('     frquence de calcul (Hz)='+floattostr(freqEM));
  memo1.Lines.Add('     distance vibration proton (m)='+floattostr(distvibEM));
  memo1.Lines.Add('absorption lumineuse vers Ir ='+floattostr(abslum));
  memo1.Lines.Add('     rflexion EM ='+floattostr(absEM));
  memo1.Lines.Add('Temps (sec)orbitale de N2 dans ciel bleu ='+floattostr(torbitale));
  memo1.Lines.Add('Temps (sec)contact possible dans ciel bleu ='+floattostr(tcontact));
  memo1.Lines.Add('vitesse ? theorique proton ? puis molecules thermodynamiques =');
  memo1.Lines.Add(floattostr(vmolecules));
  {if h>=0*50000 then writeln('nbr mol par m3 (  ) = ',nbrmolparm3);      }
  if h>=0*50000 then writeln('rho (kg/m3) = ',{distance}rho);
  if h>=0*50000 then writeln('p (N/m2) = ',pmes);
  if h>=0*50000 then writeln('altitude (m) = ',h);

  if torbitale*0.75e6{grand chiffre corrl???
  ???0.75e-10=0.75e6*1e-16???
   avec 150      w/m2 pour ciel bleu
   mesur 20/04/2015 avec 2 capteurs et altitude dduite}<tcontact then
  begin
    memo1.Lines.Add('BLEU CIEL');
    amplbleu:=amplbleu+150.0*nbrmolparm2*2*(3.1416*sqr(1e-16){150w/m2 mesure});
    altbleu:=h;{autoexcitation du bleu sur lui-mme} {gaz transparent hors noyau}
  end;
  memo1.Lines.Add('flux lum. ciel (100%)='+floattostr(amplbleu));
  memo1.Lines.Add('dbut ciel bleu de l''azote (m) ='+floattostr(altbleu));
  memo1.Lines.Add('vide spatial  l''altitude de (m) = '+floattostr(vide));
  memo1.Lines.Add('');
  {writeln(THatmosphere,h,'  ',p,'  ',Nbrmolparm3,'  ',abslum,'  ',absEM);   }
  writeln(THatmosphere,h,'  ',pmes,'  ',t,' ',nbrmolparm3,' ',rho);
  canvas.Pen.Color:=clwhite;
  canvas.Brush.Color:=clwhite;
  if courbechoisie=1 then
  begin
    canvas.MoveTo(round(550+h/1000000*850),round(800-h/1000000*700));
    canvas.Rectangle(round(550+h/1000000*850)-1,round(800-h/1000000*700)-1,
                     round(550+h/1000000*850)+1,round(800-h/1000000*700)+1);
  end;
  if courbechoisie=2 then
  begin
    canvas.MoveTo(round(550+pmes/1.013e5*850),round(800-h/1000000*700));
    canvas.Rectangle(round(550+pmes/1.013e5*850)-1,round(800-h/1000000*700)-1,
                     round(550+pmes/1.013e5*850)+1,round(800-h/1000000*700)+1);
  end;
  if courbechoisie=3 then
  begin
    canvas.MoveTo(round(550+t/273.15*850/2),round(800-h/1000000*700));
    canvas.Rectangle(round(550+t/273.15*850/2)-1,round(800-h/1000000*700)-1,
                     round(550+t/273.15*850/2)+1,round(800-h/1000000*700)+1);
  end;
  if courbechoisie=4 then
  begin
    canvas.MoveTo(round(550+amplbleu/1*850),round(800-h/1000000*700));
    canvas.Rectangle(round(550+amplbleu/1*850)-1,round(800-h/1000000*700)-1,
                     round(550+amplbleu/1*850)+1,round(800-h/1000000*700)+1);
  end;
  if courbechoisie=5 then
  begin
    canvas.MoveTo(round(550+(-abslum+1)/1*850),round(800-h/1000000*700));
    canvas.Rectangle(round(550+(-abslum+1)/1*850)-1,round(800-h/1000000*700)-1,
                     round(550+(-abslum+1)/1*850)+1,round(800-h/1000000*700)+1);
  end;
  if courbechoisie=6 then
  begin
    canvas.MoveTo(round(550+absEM/1*850),round(800-h/1000000*700));
    canvas.Rectangle(round(550+absEM/1*850)-1,round(800-h/1000000*700)-1,
                     round(550+absEM/1*850)+1,round(800-h/1000000*700)+1);
  end;
  if courbechoisie=7 then
  begin
    if modifvit then canvas.Pen.Color:=rgb(255,0,0)
                else canvas.Pen.Color:=rgb(255,255,255);
    canvas.MoveTo(round(550+rho/1.22*850),round(800-h/1000000*700));
    canvas.Rectangle(round(550+rho/1.22*850)-1,round(800-h/1000000*700)-1,
                     round(550+rho/1.22*850)+1,round(800-h/1000000*700)+1);
    canvas.Pen.Color:=rgb(0,255,0);
    canvas.MoveTo(round(550+Rvrai/5000*850),round(800-h/1000000*700));
    canvas.Rectangle(round(550+Rvrai/5000*850)-1,round(800-h/1000000*700)-1,
                     round(550+Rvrai/5000*850)+1,round(800-h/1000000*700)+1);
  end;
  if courbechoisie=8 then
  begin
    canvas.MoveTo(round(550+(abslumem)/1*850),round(800-h/1000000*700));
    canvas.Rectangle(round(550+(abslumem)/1*850)-1,round(800-h/1000000*700)-1,
                     round(550+(abslumem)/1*850)+1,round(800-h/1000000*700)+1);
  end;
  if courbechoisie=9 then
  begin
    canvas.Pen.Color:=rgb(0,0,0);{rgb(255,255,255);    }
    canvas.MoveTo(round(550+(vmolecules)/10000.0*850),round(800-h/1000000*700));
    canvas.Rectangle(round(550+(vmolecules)/10000.0*850)-1,round(800-h/1000000*700)-1,
                     round(550+(vmolecules)/10000.0*850)+1,round(800-h/1000000*700)+1);
    canvas.Pen.Color:=rgb(0,0,0){rgb(255,255,255)};
    canvas.MoveTo(round(550+(vthermo)/10000.0*850),round(800-h/1000000*700));
    canvas.Rectangle(round(550+(vthermo)/10000.0*850)-1,round(800-h/1000000*700)-1,
                     round(550+(vthermo)/10000.0*850)+1,round(800-h/1000000*700)+1);
    canvas.pen.Color:=rgb(255,0,0);
    canvas.MoveTo(round(550+(ktherm)/0.001*850),round(800-h/1000000*700));
    canvas.Rectangle(round(550+(ktherm)/0.001*850)-1,round(800-h/1000000*700)-1,
                     round(550+(ktherm)/0.001*850)+1,round(800-h/1000000*700)+1);
    canvas.pen.Color:=rgb(0,255,255);
    canvas.MoveTo(round(550+(teqvitesse)/120000.0*850),round(800-h/1000000*700));
    canvas.Rectangle(round(550+(teqvitesse)/120000.0*850)-1,round(800-h/1000000*700)-1,
                     round(550+(teqvitesse)/120000.0*850)+1,round(800-h/1000000*700)+1);
    canvas.pen.Color:=rgb(255,255,0);
    canvas.MoveTo(round(550+(distance*1e9)/1000000.0*850),round(800-h/1000000*700));
    canvas.Rectangle(round(550+(distance*1e9)/1000000.0*850)-1,round(800-h/1000000*700)-1,
                     round(550+(distance*1e9)/1000000.0*850)+1,round(800-h/1000000*700)+1);
    {canvas.pen.Color:=rgb(255,0,255);
    canvas.MoveTo(round(550+(nbrmolparm3)/6e23*850),round(800-h/1000000*700));
    canvas.Rectangle(round(550+(nbrmolparm3*1e9)/6e23*850)-1,round(800-h/1000000*700)-1,
                     round(550+(distance*nbrmolparm3)/6e23*850)+1,round(800-h/1000000*700)+1);    }
  end;
  h:=h-1000.0;
  for i := 1 to delay do j:=i;

end;
  closefile(THatmosphere);
end;

end.
